import 'package:yuro_core/yuro_core.dart';
import 'package:yuro_instance/yuro_instance.dart';

abstract class Binding {
  void dependencies();
}

class BindingBuilder<T> extends Binding {
  BindingBuilder(this.build);

  factory BindingBuilder.put(InstanceBuilder<T> builder, {String tag, bool permanent}) {
    return BindingBuilder(() => Yuro.put<T>(builder(), tag: tag, permanent: permanent));
  }

  final Function() build;

  @override
  void dependencies() => build();
}
